//////////////////////////////////////////////////////////////////////
// Belief propagation for polytrees inference algorithm
//
// TODO: recursively propagate/request messages
//////////////////////////////////////////////////////////////////////

function runtests() {
  var testText = document.getElementById("testText");

  var results = '';

  var foo = 'foo<br>';
  foo = foo.charAt(0) + foo.charAt(1).toUpperCase() + foo.substr(2,5);
  results += foo;

  results += bnTest();
  results += inferenceTest();

  testText.innerHTML = results;
}

function inferenceTest() {
  var rv = "";

  var bnet = {};
  var cause = new bnNode();
  cause.bnet = bnet;
  bnet['cause'] = cause;
  cause.name = "cause";
  // lowercase for failed, uppercase for OK
  // Local net, Web server, DNS, IP
  cause.range = [
		 'lwdi',
		 'lwdI',
		 'lwDi',
		 'lwDI',
		 'lWdi',
		 'lWdI',
		 'lWDi',
		 'lWDI',
		 'Lwdi',
		 'LwdI',
		 'LwDi',
		 'LwDI',
		 'LWdi',
		 'LWdI',
		 'LWDi',
		 'LWDI',
		 ];
  cause.children = ['obconn', 'cffu', 'http', 'cfts', 'ffox'];
  cause.cpt = {};
  cause.cpt['lwdi|'] = 1.0 / 16;
  cause.cpt['lwdI|'] = 1.0 / 16;
  cause.cpt['lwDi|'] = 1.0 / 16;
  cause.cpt['lwDI|'] = 1.0 / 16;
  cause.cpt['lWdi|'] = 1.0 / 16;
  cause.cpt['lWdI|'] = 1.0 / 16;
  cause.cpt['lWDi|'] = 1.0 / 16;
  cause.cpt['lWDI|'] = 1.0 / 16;
  cause.cpt['Lwdi|'] = 1.0 / 16;
  cause.cpt['LwdI|'] = 1.0 / 16;
  cause.cpt['LwDi|'] = 1.0 / 16;
  cause.cpt['LwDI|'] = 1.0 / 16;
  cause.cpt['LWdi|'] = 1.0 / 16;
  cause.cpt['LWdI|'] = 1.0 / 16;
  cause.cpt['LWDi|'] = 1.0 / 16;
  cause.cpt['LWDI|'] = 1.0 / 16;

  var obconn = new bnNode();
  obconn.bnet = bnet;
  bnet['obconn'] = obconn;
  obconn.name = 'obconn';
  obconn.range = ['OK', 'FAIL'];
  obconn.parents = ['cause'];
  obconn.cpt = {};
  for (var i=0; i<cause.range.length; i++) {
    var causeVal = cause.range[i];
    if (causeVal[0] == 'l') {
      // local net failed
      obconn.cpt['OK|'   + causeVal] = 0.0;
      obconn.cpt['FAIL|' + causeVal] = 1.0;
    } else {
      // local net okay
      obconn.cpt['OK|'   + causeVal] = 0.98;
      obconn.cpt['FAIL|' + causeVal] = 0.02;
    }
  }

  var cffu = new bnNode();
  cffu.bnet = bnet;
  bnet['cffu'] = cffu;
  cffu.name = 'cffu';
  cffu.range = [0, 1, 2];
  cffu.parents = ['cause'];
  cffu.cpt = {};

  for (var i=0; i<cause.range.length; i++) {
    var causeVal = cause.range[i];
    if (causeVal[0] == 'l') {
      // local net failed
      cffu.cpt['0|' + causeVal] = 0.5;
      cffu.cpt['1|' + causeVal] = 0.3;
      cffu.cpt['2|' + causeVal] = 0.2;
    } else {
      // local net okay
      cffu.cpt['0|' + causeVal] = 0.95;
      cffu.cpt['1|' + causeVal] = 0.04;
      cffu.cpt['2|' + causeVal] = 0.01;
    }
  }

  var http = new bnNode();
  http.bnet = bnet;
  bnet['http'] = http;
  http.name = 'http';
  http.range = ['OK', 'FAIL'];
  http.parents = ['cause'];
  http.cpt = {};

  for (var i=0; i<cause.range.length; i++) {
    var causeVal = cause.range[i];
    if (causeVal == 'LWDI') {
      // everything is okay
      http.cpt['OK|'   + causeVal] = 1.0;
      http.cpt['FAIL|' + causeVal] = 0.0;
    } else {
      // something has failed
      http.cpt['OK|'   + causeVal] = 0.0;
      http.cpt['FAIL|' + causeVal] = 1.0;
    }
  }

  var cfts = new bnNode();
  cfts.bnet = bnet;
  bnet['cfts'] = cfts;
  cfts.name = 'cfts';
  cfts.range = [0, 1, 2];
  cfts.parents = ['cause'];
  cfts.cpt = {};

  for (var i=0; i<cause.range.length; i++) {
    var causeVal = cause.range[i];
    if (causeVal[1] == 'w') {
      // web server failed
      cfts.cpt['0|' + causeVal] = 0.1;
      cfts.cpt['1|' + causeVal] = 0.3;
      cfts.cpt['2|' + causeVal] = 0.6;
    } else {
      // web server okay
      cfts.cpt['0|' + causeVal] = 0.97;
      cfts.cpt['1|' + causeVal] = 0.02;
      cfts.cpt['2|' + causeVal] = 0.01;
    }
  }

  var ffox = new bnNode();
  ffox.bnet = bnet;
  bnet['ffox'] = ffox;
  ffox.name = 'ffox';
  ffox.range = [0, 14, 30];
  ffox.parents = ['cause'];
  ffox.cpt = {};

  for (var i=0; i<cause.range.length; i++) {
    var causeVal = cause.range[i];
    if (causeVal[1] == 'D') {
      // dns failure
      ffox.cpt['0|' + causeVal] = 0.1;
      ffox.cpt['14|' + causeVal] = 0.3;
      ffox.cpt['30|' + causeVal] = 0.9;
    } else {
      // no dns failure
      ffox.cpt['0|' + causeVal] = 0.97;
      ffox.cpt['14|' + causeVal] = 0.01;
      ffox.cpt['30|' + causeVal] = 0.02;
    }
  }

  rv += "<br><h2>Belief propagation test</h2>";
  for (var childId=0; childId<cause.children.length; childId++) {
    var childName = cause.children[childId];
    bnet[childName].calcLambda();
    bnet[childName].calcLambdaMessages();
  }

  cause.updateBelief();
  
  for (var childId=0; childId<cause.children.length; childId++) {
    var childName = cause.children[childId];
    bnet[childName].updateBelief();
  }

  for (var nodeName in bnet) {
    var node = bnet[nodeName];
    for (var valId=0; valId<node.range.length; valId++) {
      var val = node.range[valId];
      rv += nodeName + '.bel[' + val + '] == ' + Math.round(node.bel[val] * 10000) / 10000 + '<br>';
    }
  }

  rv += "<h2>Evidence test</h2>";

  obconn.setEvidence('FAIL');

  for (var childId=0; childId<cause.children.length; childId++) {
    var childName = cause.children[childId];
    bnet[childName].calcLambda();
    bnet[childName].calcLambdaMessages();
  }

  cause.updateBelief();
  
  for (var childId=0; childId<cause.children.length; childId++) {
    var childName = cause.children[childId];
    bnet[childName].updateBelief();
  }

  for (var nodeName in bnet) {
    var node = bnet[nodeName];
    for (var valId=0; valId<node.range.length; valId++) {
      var val = node.range[valId];
      rv += nodeName + '.bel[' + val + '] == ' + Math.round(node.bel[val] * 10000) / 10000 + '<br>';
    }
  }

  return rv;
}

// A --> B
function bnTest() {
  var errors = "";

  function assertEquals(x, y) {
    if (!eval("(" + x + ") == (" + y + ")")) {
      errors += "assertion failed: ";
      errors += x + " == " + eval(x) + ", ";
      errors += y + " == " + eval(y) + "<br>";
    }
  }

  var bnet = {};

  var a = new bnNode();
  a.bnet = bnet;
  a.name = "A";
  a.cpt = {};
  a.range = ['a1', 'a2'];
  a.children = ["B"];
  a.cpt["a1|"] = 0.1;
  a.cpt["a2|"] = 0.9;

  var b = new bnNode();
  b.bnet = bnet;
  b.name = "B";
  b.cpt = {};
  b.range = ['b1', 'b2'];
  b.parents = ["A"];
  b.cpt["b1|a1"] = 0.3;
  b.cpt["b1|a2"] = 0.8;
  b.cpt["b2|a1"] = 0.7;
  b.cpt["b2|a2"] = 0.2;

  bnet["A"] = a;
  bnet["B"] = b;

  b.calcLambda();
  b.calcLambdaMessages();
  
  a.updateBelief();
  b.updateBelief();

  assertEquals("a.pi['a1']", "0.1");
  assertEquals("a.pi['a2']", "0.9");

  assertEquals("a.piMessages[0]['a1']", "0.1");
  assertEquals("a.piMessages[0]['a2']", "0.9");

  assertEquals("a.lambdaFromChildren['B']['a1']", "1");
  assertEquals("a.lambdaFromChildren['B']['a2']", "1");

  assertEquals('b.lambda["b1"]', '1');
  assertEquals('b.lambda["b2"]', '1');

  assertEquals('Math.round(b.pi["b1"] * 10000)', '.75 * 10000');
  assertEquals('Math.round(b.pi["b2"] * 10000)', '.25 * 10000');

  assertEquals('b.lambdaMessages[0]["a1"]', '1');
  assertEquals('b.lambdaMessages[0]["a2"]', '1');

  assertEquals("b.piFromParents['A']['a1']", "0.1");
  assertEquals("b.piFromParents['A']['a2']", "0.9");

  assertEquals('Math.round(a.bel["a1"] * 10000)', '.1 * 10000');
  assertEquals('Math.round(a.bel["a2"] * 10000)', '.9 * 10000');

  assertEquals('Math.round(b.bel["b1"] * 10000)', '.75 * 10000');
  assertEquals('Math.round(b.bel["b2"] * 10000)', '.25 * 10000');

  b.setEvidence('b1');

  assertEquals('b.lambda["b1"]', '1');
  assertEquals('b.lambda["b2"]', '0');

  b.calcLambdaMessages();
  
  a.updateBelief();
  b.updateBelief();

  assertEquals('Math.round(a.bel["a1"] * 10000)', '.04 * 10000');
  assertEquals('Math.round(a.bel["a2"] * 10000)', '.96 * 10000');

  assertEquals('Math.round(b.bel["b1"] * 10000)', '1.0 * 10000');
  assertEquals('Math.round(b.bel["b2"] * 10000)', '0.0 * 10000');
  
  assertEquals("a.lambdaFromChildren['B']['a1']", "0.3");
  assertEquals("a.lambdaFromChildren['B']['a2']", "0.8");

  b.clearEvidence();

  // add evidence for a1 through a dummy node
  var c = new bnNode();
  c.bnet = bnet;
  c.name = "C";
  c.cpt = {};
  c.range = ['c0'];
  c.parents = ["A"];
  c.cpt["c0|a1"] = 1.0;
  c.cpt["c0|a2"] = 0.0;
  bnet["C"] = c;
  a.children.push("C");

  b.calcLambda();
  b.calcLambdaMessages();

  c.setEvidence("c0");
  c.calcLambda();
  c.calcLambdaMessages();
  a.updateBelief();
  b.updateBelief();
  c.updateBelief();

  assertEquals("a.lambdaFromChildren['C']['a1']", "1.0");
  assertEquals("a.lambdaFromChildren['C']['a2']", "0.0");

  assertEquals('Math.round(a.bel["a1"] * 10000)', '1.0 * 10000');
  assertEquals('Math.round(a.bel["a2"] * 10000)', '0.0 * 10000');

  assertEquals('Math.round(c.bel["c0"] * 10000)', '1.0 * 10000');

  assertEquals("a.piMessages[0]['a1']", "1.0");
  assertEquals("a.piMessages[0]['a2']", "0.0");

  assertEquals("b.piFromParents['A']['a1']", "1.0");
  assertEquals("b.piFromParents['A']['a2']", "0.0");

  assertEquals('Math.round(b.bel["b1"] * 10000)', '0.3 * 10000');
  assertEquals('Math.round(b.bel["b2"] * 10000)', '0.7 * 10000');

  if (errors == "") {
    errors = "All tests passed.";
  }

  return errors;
};

function bnNode() {
  this.cpt = {},                // cpt["var|parents"]
  this.bel = {};                // belief
  this.lambda = {};		// lambda calculation used locally	    
  this.pi = {};			// pi calculation used locally	    
  this.lambdaFromChildren = {};	// lambda messages received from children 
  this.piFromParents = {};	// pi messages received from parents      
  this.range = [];		// list of possible values for this variable
  this.children = [];           // list of children
  this.parents = [];            // list of parents
  this.lambdaMessages = [];     // lambda messages to be sent to parents
  this.piMessages = [];         // pi messages to be sent to children
};

bnNode.prototype = {
  bnet: null,             // associative array of all nodes
  name: "",               // name of this variable
  evidence: false,        // whether this is an evidence node

  setEvidence: function(observedValue) {
    for (var i=0; i<this.range.length; i++) {
      var val = this.range[i];
      if (val == observedValue) {
	this.lambda[val] = 1;
      } else {
	this.lambda[val] = 0;
      }
    }
    this.evidence = true;
  },

  clearEvidence: function() {
    this.evidence = false;
  },

//   activate: function(fromNode) {
//     // recursively request messages from all neighbors, and then send
//     // a message back.  Like a depth first search.
//     //
//     // 1. For each neighbor except fromNode, check to see if I have a
//     // message from them.
//     // 2. Recursively activate all nodes whom I haven't heard from.
//     // 3. Send a message to all other fromNode.

//     var fromNodeName = fromNode.name;

//     for (childId=0; childId<this.children.length; childId++) {
//       var childName = this.children[childId];
//       var childNode = this.bnet[childName];
//       if (childName != fromNodeName &&
// 	  lambdaFromChildren[childName] == undefined) {
// 	childNode.activate(this);
//       }
//     }

//     for (parentId=0; parentId<this.parents.length; parentId++) {
//       var parentName = this.parents[parentId];
//       var parentNode = this.bnet[parentName];
//       if (parentName != fromNodeName &&
// 	  piFromParents[parentName] == undefined) {
// 	childNode.activate(this);
//       }
//     }
//   },

//   sendMessages: function() {
//     // determine if this node can send any messages; if so, send them.
//     // Return whether it was able to send any messages.
//     //
//     // For each neighbor, check to see if we have received messages
//     // from all other neighbors.  If so, send a message to the
//     // neighbor.
//     //
//     // Next check to see if that neighbor can now send any new
//     // messages to its neighbors.

//     // If we are an edge node with only one neighbor, then we can
//     // propagate a message before receiving any other messages.

//     if (this.parents.length == 1 && this.children.length == 0) {
//       // Leaf node.  Calculate lambda and send lambda message to
//       // parent.
//       this.calcLambda();
//       this.calcLambdaMessages();
//     } else if (this.parents.length == 0 && this.children.length == 1) {
//       // Root node.  calculate pi and send pi message to child.
//       this.calcPi();
//       this.calcPiMessages();
//     }
    
//     // Otherwise, if we've received lambda messages from all our
//     // children and pi messages from all our parents, then we can send
//     // lambda messages to our parents and pi messages to our children.
//     if (this.lambdaFromChildren.length == children.length) {
//       this.calcLambda();
//       this.calcLambdaMessages();
//     }

//     if (this.piFromParents.length == parents.length) {
//       this.calcPi();
//       this.calcPiMessages();
//     }
//   },

  updateBelief: function() {
    // update beliefs
    
    // sum of all beliefs for normalization purposes
    var belSum = 0.0;

    // calculate pi and lambda values
    this.calcLambda();
    this.calcPi();

    // update belief
    for (var i=0; i<this.range.length; i++) {
      var val = this.range[i];
      this.bel[val] = this.lambda[val] * this.pi[val];
      belSum += this.bel[val];
    }
    
    // normalize beliefs
    for (var i=0; i<this.range.length; i++) {
      var val = this.range[i];
      this.bel[val] /= belSum;
    }

    this.calcLambdaMessages();
    this.calcPiMessages();
  },

  nextParentValueIds: function(parentValueIds) {
    // return the next possible combination of values for the parents
    // in parentValues.  parentValues is an array of parent value
    // indices in the same order as this.parents.  If parentValues is
    // null, start with the first possible combination of parent
    // values.
    //
    // The first parent value changes most rapidly.  If there are no
    // more values, return null.

    var nextValues = new Array();
    
    if (parentValueIds == null) {
      for (var i=0; i<this.parents.length; i++) {
	nextValues.push(0);
      }
    } else {
      var noMoreValues = true;
      for (var i=0; i<this.parents.length; i++) {
	var parent = this.parents[i];
	var maxValue = this.bnet[parent].range.length - 1;
	if (parentValueIds[i] < maxValue) {
	  parentValueIds[i]++;
	  noMoreValues = false;
	  break;
	} else {
	  parentValueIds[i] = 0;
	}
      }
      
      if (noMoreValues) {
	nextValues = null;
      } else {
	nextValues = parentValueIds;
      }
    }

    return nextValues;
  },

  getParentValues: function(parentValueIds) {
    // given a list of parent value ids, return the actual parent values.
    //
    var parentValues = new Array();

    for (var parentId=0; parentId<this.parents.length; parentId++) {
      var parentName = this.parents[parentId];
      var parentNode = this.bnet[parentName];
      var parentValueId = parentValueIds[parentId];
      var parentValue = parentNode.range[parentValueId];
      parentValues.push(parentValue);
    }
    return parentValues;
  },

  calcLambda: function() {
    if (this.evidence) {
      // if we already have evidence, no need to update lambda
      return;
    }
    // calculate lambda from messages received from children
    for (var i=0; i<this.range.length; i++) {
      var val = this.range[i];
      this.lambda[val] = 1.0;
      for (var j=0; j<this.children.length; j++) {
	var child = this.children[j];
	if (this.lambdaFromChildren[child] == undefined) {
	  alert(this.name + ".calcLambda(): lambdaFromChildren[" + child + "] not defined");
	}
	this.lambda[val] *= this.lambdaFromChildren[child][val];
      }
    }
  },
  
  calcPi: function() {
    // calculate pi values
    
    
    for (var i=0; i<this.range.length; i++) {
      var val = this.range[i];
      this.pi[val] = 0;
      
      var parentValueIds = null;
      while (true) {
	var parentValueIds = this.nextParentValueIds(parentValueIds);
	if (parentValueIds == null) {
	  break;
	}
	var parentValues = this.getParentValues(parentValueIds);
	
	var prod = 1;
	for (var j=0; j<this.parents.length; j++) {
	  var parent = this.parents[j];
	  var piFromParent = this.piFromParents[parent][parentValues[j]];
	  prod *= piFromParent;
	}
	var parentValues = this.getParentValues(parentValueIds);

	var key = val + "|" + parentValues.join(",");
	var parentsProb = this.cpt[key];
	if (parentsProb == null) {
	  alert("parentsProb[" + key + "] == null");
	}

	prod *= parentsProb;
	this.pi[val] += prod;
      }
    }
  },

  calcLambdaMessages: function() {
    var lambdaMessages = new Array();
    for (var toParentId=0; toParentId<this.parents.length; toParentId++) {
      var lambdaMessage = this.calcLambdaMessage(toParentId);
      lambdaMessages.push(lambdaMessage);
    }
    this.lambdaMessages = lambdaMessages;
  },

  calcLambdaMessage: function(toParentId) {
    // calculate the lambda message to send to toParentId
    // for each parent to whom to send a message
    var lambdaMessage = {};
    var toParent = this.parents[toParentId];
    var toParentNode = this.bnet[toParent];

    // for each parent value
    for (var toParentValId=0;
	 toParentValId<toParentNode.range.length;
	 toParentValId++) {
      var toParentVal = toParentNode.range[toParentValId];
	
      // sum over x of lambda(x) * innerSum
      var outerSum = 0;

      for (var valId = 0; valId < this.range.length; valId++) {
	var val = this.range[valId];

	// sum of conditional probabilities from parents
	var innerSum = 0;
	var parentValueIds = null;
	while (true) {
	  var parentValueIds = this.nextParentValueIds(parentValueIds);
	  if (parentValueIds == null) {
	    break;
	  }
	  // u_k: k!=i
	  if (parentValueIds[toParentId] != toParentValId) {
	    continue;
	  }

	  var parentValues = this.getParentValues(parentValueIds);

	  // compute the product of all pi messages received from
	  // other parents.
	  var prod = 1.0;
	  for (var fromParentId=0;
	       fromParentId<this.parents.length;
	       fromParentId++) {
	    var fromParent = this.parents[fromParentId];
	    if (fromParentId == toParentId) {
	      continue;
	    }
	    var fromParentValue = parentValues[fromParentId];
	    prod *= this.piFromParents[fromParent][fromParentValue];
	  }

	  var key = val + "|" + parentValues.join(",");
	  var parentsProb = this.cpt[key];
	  if (parentsProb == null) {
	    alert("parentsProb[" + key + "] == null");
	  }
	  prod *= parentsProb;
	  innerSum += prod;
	}
	outerSum += this.lambda[val] * innerSum;
      }
      lambdaMessage[toParentVal] = outerSum;
    }
    toParentNode.lambdaFromChildren[this.name] = lambdaMessage;
    return lambdaMessage;
  },

  calcPiMessages: function() {
    var piMessages = new Array();

    for (var childId = 0; childId<this.children.length; childId++) {
      var piMessage = this.calcPiMessage(childId);
      piMessages.push(piMessage);
    }
    this.piMessages = piMessages;
  },

  calcPiMessage: function(toChildId) {
    // calculate the pi messages that go to children.
    //
    var debug = false;
    var piMessage = {};
    var toChild = this.children[toChildId];
    var toChildNode = this.bnet[toChild];
    var sum = 0; // for normalization
    for (var i=0; i<this.range.length; i++) {
      var val = this.range[i];

      piMessage[val] = this.pi[val];
      
      for (var otherChildId = 0; otherChildId<this.children.length; otherChildId++) {
	var otherChild = this.children[otherChildId];
	if (toChildId == otherChildId) {
	  continue;
	}
	piMessage[val] *= this.lambdaFromChildren[otherChild][val];
      }
      sum += piMessage[val];
    }

    for (var i=0; i<this.range.length; i++) {
      var val = this.range[i];
      piMessage[val] /= sum;
    }
    toChildNode.piFromParents[this.name] = piMessage;

    return piMessage;
  }
};
